#include <stdio.h>
#include <netdb.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#define SERV_PORT  5134

#define MAXNAME    1024

main(argc, argv)
int argc;
char **argv;
{
   int fd;                  /* fd into transport provider */
   int i;                   /* loops through user names   */
   int length;              /* length of message          */
   char buf[BUFSIZ];        /* holds message from server  */
   struct hostent *hp;      /* holds IP address of server */
   struct sockaddr_in myaddr; /* address that client uses */
   struct sockaddr_in servaddr; /* the server's full addr */
   /*
    *  Check for proper usage.
    */

   if (argc < 3) {
      fprintf(stderr,
              "Usage: %s host user [user...]\n", argv[0]);
      exit(2);
   }

   /*
    *  Get a socket into TCP/IP.
    */

   if ((fd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
      perror("socket failed!");
      exit(1);
   }

   /*
    *  Bind to an arbitrary return address.
    */

   bzero((char *)&myaddr, sizeof(myaddr));
   myaddr.sin_family = AF_INET;
   myaddr.sin_addr.s_addr = htonl(INADDR_ANY);
   myaddr.sin_port = htons(0);

   if (bind(fd, (struct sockaddr *)&myaddr,
                                   sizeof(myaddr)) < 0) {
      perror("bind failed!");
      exit(1);
   }
   /*
    *  Fill in the server's address and the data.
    */

   bzero((char *)&servaddr, sizeof(servaddr));
   servaddr.sin_family = AF_INET;
   servaddr.sin_port = htons(SERV_PORT);

   hp = gethostbyname(argv[1]);
   if (hp == 0) {
      fprintf(stderr, "could not obtain address of %s\n",
         argv[2]);
      return (-1);
   }

   bcopy(hp->h_addr_list[0], (caddr_t)&servaddr.sin_addr,
      hp->h_length);

   /*
    *  Connect to the server.
    */

   if (connect(fd, (struct sockaddr *)&servaddr,
                          sizeof(servaddr)) < 0) {
      perror("connect failed!");
      exit(1);
   }
   for (i = 2; i < argc; i++) {
      /*
       *  Write the user name and read the response.
       */
   
      length = strlen(argv[i]) + 1;
      if (write(fd, argv[i], length) != length) {
         perror("write failed!\n");
         exit(1);
      }
   
      if (read(fd, buf, 1) == -1) {
         perror("read failed!\n");
         exit(1);
      }
   
      if (buf[0] == 'y') {
         printf("%s is logged on server\n", argv[i]);
      } else {
         printf("%s is not logged on server\n", argv[i]);
      }
   }
   (void)shutdown(fd, 2);
   exit(0);
}
